# ESP32 Code

If you would like to edit the code, feel free to edit `esp32.c`
Feel free to change any options in the Makefile to help it work for your system.
For example, where the Arduino libraries are held, the connecting baud rate, etc.
Should work by default in most distributions.

## Pinout

The board used in this project has a unique pin layout that isn't very common.
The pin layout has been documented in the `pinout` directory both in image and markdown form.

## Installing Dependencies

To install the dependencies for the board, use the `make install-deps` command.

You will also need to manually install the following packages/libraries:

* `pyserial`, a Python library
  * `pip install pyserial`
* `tmux` and `screen` for serial viewing
  * `apt install tmux screen`
  * `pacman -S tmux screen`
  * etc.
* `arduino-cli` from your package manager

## Compiling The Code

To compile the source file, run the following command: `make`

## Upload the code

If you would like to upload the code to a connected device, use the `make upload` command.

## Troubleshooting

If you recieve an error about the `serial` package is not found, use the following command to install Python's serialization library:

```bash
$ pip install pyserial
```

### My GPS isn't receiving data!

Hold your horses.
This process may take a few minutes.
The GPS chip needs to find all the nearby satealites, establish a connection, then calculate where it might be based on that data.
This can take somewhere between a few seconds and a few minutes during the first boot depending on how easily you have a direct view to the sky.
