# ESP32 Pinout

The model of ESP32 used in this project has a unique pin layout compared to other ESP32 boards, and even with board that have a similar model number.
The DOIT Devkit V1 normally has a GND (ground) pin directly next to the 3v3 pin (3.3V power), but this board specifically has its CLK (clock cycle) pin directly beside the 3v3 pin.

The layout is as follows, with the board in the center between the two sides.
Slashes are used to determine specialty use cases for the individual pins.
For example GIPO4/TOUCH0 would indicate that the pin, although is designed especially for touch events, is also usable as a GPIO pin.

Left Side|Right Side
---|---
EN|GPIO23/VSPI MOSI
GPIO36/RTC_GPIO0/Sensor VP/ADC1 CH0|GPIO22/I2C SCL
GPIO39/RTC_GPIO3/Sensor VN/ADC1 CH3|GPIO1/UART 0 TX
GPIO34/RTC_GPIO4/ADC1 CH6|GPIO3/UART 0 RX
GPIO35/RTC_GPIO5/ADC1 CH7|GPIO21/I2C SDA
GPIO32/RTC_GPIO9/TOUCH9/ADC1 CH4|GPIO19/VSPI MISO
GPIO33/RTC_GPIO8/TOUCH8/ADC1 CH5|GPIO18/VSPI CLK
GPIO25/RTC_GPIO6/DAC1/ADC2 CH8|GPIO5/VSPI CS0
GPIO26/RTC_GPIO7/DAC2/ADC2 CH9|GPIO17/UART 2 TX
GPIO27/RTC_GPIO17/TOUCH7/ADC2 CH7|GPIO16/UART 2 RX
GPIO14/RTC_GPIO16/HSPI CLK/TOUCH6/ADC2 CH6|GPIO4/ADC2 CH0/TOUCH0/RTC_GPIO10
GPIO12/RTC_GPIO15/HSPI MISO/TOUCH5/ADC2 CH5|GPIO2/ADC2 CH2/TOUCH2/RTC_GPIO12
GPIO13/RTC_GPIO14/HSPI MOSI/TOUCH4/ADC2 CH4|GPIO15/ADC2 CH3/TOUCH3/HSPI CS0/RTC_GPIO13
\[[1](#note-1)\]GPIO9/SHD/SD2|GPIO0/ADC2 CH1/TOUCH1/RTC_GPIO11
\[[1](#note-1)\]GPIO10/SWP/SD3|\[[1](#note-1)\]GPIO8/SDI/SD1
\[[1](#note-1)\]GPIO11/CSC/CMD|\[[1](#note-1)\]GPIO7/SDO/SD0
GND|\[[1](#note-1)\]GPIO6/SCK/CLK
VIN|3V3

<p id="note-1">
Pins SCK/CLK, SDO/SD0, SDI/SD1, SHD/SD2, SWP/SD3, and SCS/CMD, namely, GPIO6 to GPIO11 are connected to the integrated SPI flash on ESP-WROOM-32 and are not recommended for other uses.
</p>
